package com.utopiaindustries.hseobservationsapp.activities.HSETrainingForms;

import android.Manifest;
import android.annotation.SuppressLint;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.drawable.ColorDrawable;
import android.media.ExifInterface;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.FileProvider;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.activities.DashboardActivity;
import com.utopiaindustries.hseobservationsapp.activities.PermitToWorkForms.PermitTwoActivity;
import com.utopiaindustries.hseobservationsapp.adapters.BuildingsAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.DepartmentAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.FloorsAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.PTWImageAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.SafetyTrainingAdapter;
import com.utopiaindustries.hseobservationsapp.helper.Helper;
import com.utopiaindustries.hseobservationsapp.models.DocumentTypeImageModel;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseBuilding;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseDepartment;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseFloor;
import com.utopiaindustries.hseobservationsapp.models.HseData.HseSafetyTrainingTopic;
import com.utopiaindustries.hseobservationsapp.utils.StorageManager.StorageManager;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Objects;
import java.util.function.Consumer;
import java.util.stream.Collectors;

import pub.devrel.easypermissions.AfterPermissionGranted;
import pub.devrel.easypermissions.AppSettingsDialog;
import pub.devrel.easypermissions.EasyPermissions;

public class HseOneActivity extends AppCompatActivity {


    String docTypeId = "";
    String docTypeTitle = "";

    ImageView imgBack;
    Button btnNext;
    AutoCompleteTextView safetyTextview, targetAudienceTextview, locationTextview, subLocationTextView;

    private ArrayList<HseSafetyTrainingTopic> safetyTrainingArrayList = new ArrayList<>();
    private ArrayList<HseDepartment> departmentArrayList = new ArrayList<>();
    private ArrayList<HseDepartment> departmentArrayList_temp = new ArrayList<>();

    private DepartmentAdapter departmentAdapter;
    private SafetyTrainingAdapter safetyTrainingAdapter;

    private String safetyTrainingTopic = "";
    private String targetAudience = "", location = "", subLocation = "";
    EditText etNoOfEmployees;

    private ArrayList<HseBuilding> locationArrayList_temp = new ArrayList<>();
    private ArrayList<HseBuilding> locationArrayList = new ArrayList<>();
    private BuildingsAdapter buildingAdapter;

    private ArrayList<HseFloor> subLocationArrayList_temp = new ArrayList<>();
    private ArrayList<HseFloor> subLocationArrayList = new ArrayList<>();
    private FloorsAdapter floorsAdapter;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_hse_one);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayouts();



        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (isValidate()) {
                    Intent intent = new Intent(HseOneActivity.this, HseTwoActivity.class);
                    startActivity(intent);
                }

            }
        });

        safetyTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                safetyTrainingTopic = safetyTrainingArrayList.get(position).getTitle();
                StorageManager.getInstance().getHseTrainingModel().get(0).setSafetyTopicId(safetyTrainingArrayList.get(position).getId());
            }
        });

        targetAudienceTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                targetAudience = departmentArrayList.get(position).getTitle();
                StorageManager.getInstance().getHseTrainingModel().get(0).setTargetAudienceId(departmentArrayList.get(position).getId());
            }
        });

        locationTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                location = locationArrayList.get(position).getTitle();
                StorageManager.getInstance().getHseTrainingModel().get(0).setLocationId(locationArrayList.get(position).getId());
            }
        });

        subLocationTextView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                subLocation = subLocationArrayList.get(position).getTitle();
                StorageManager.getInstance().getHseTrainingModel().get(0).setSubLocationId(subLocationArrayList.get(position).getId());
            }
        });

        etNoOfEmployees.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (!s.toString().isEmpty()) {
                    StorageManager.getInstance().getHseTrainingModel().get(0).setEmployeeAttendance(Integer.parseInt(s.toString()));
                }

            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
    }

    private void initializeLayouts() {
        imgBack = findViewById(R.id.img_back);
        btnNext = findViewById(R.id.btn_next);
        etNoOfEmployees = findViewById(R.id.et_no_of_employees);

        safetyTextview = findViewById(R.id.safety_textview);
        targetAudienceTextview = findViewById(R.id.target_audience_textview);

        locationTextview = findViewById(R.id.location_textview);
        subLocationTextView = findViewById(R.id.sub_location_textview);

        safetyTrainingArrayList.addAll(Helper.getList(Helper.hseSafetyTrainingTopics, this, HseSafetyTrainingTopic.class));
        safetyTrainingAdapter = new SafetyTrainingAdapter(this, safetyTrainingArrayList);
        safetyTextview.setAdapter(safetyTrainingAdapter);

        departmentArrayList_temp.addAll(Helper.getList(Helper.hseDepartment, this, HseDepartment.class));

        if (!departmentArrayList_temp.isEmpty()) {

            List<HseDepartment> filteredUnitItems = departmentArrayList_temp.stream()
                    .filter(item -> Objects.equals(item.getSiteId(), StorageManager.getInstance().getSite_id()))
                    .collect(Collectors.toList());

            departmentArrayList.clear();
            departmentArrayList.addAll(filteredUnitItems);
            departmentAdapter = new DepartmentAdapter(this, departmentArrayList);
            targetAudienceTextview.setAdapter(departmentAdapter);
        }

        locationArrayList_temp.addAll(Helper.getList(Helper.hseBuildings, this, HseBuilding.class));

        //Location -- Building
        if (!locationArrayList_temp.isEmpty()) {

            List<HseBuilding> filteredUnitItems = locationArrayList_temp.stream()
                    .filter(item -> Objects.equals(item.getSiteId(), StorageManager.getInstance().getSite_id()))
                    .collect(Collectors.toList());

            locationArrayList.clear();
            locationArrayList.addAll(filteredUnitItems);
            buildingAdapter = new BuildingsAdapter(this, locationArrayList);
            locationTextview.setAdapter(buildingAdapter);
        }

        subLocationArrayList_temp.addAll(Helper.getList(Helper.hseFloors, this, HseFloor.class));

        //Sub Location -- floor
        if (!subLocationArrayList_temp.isEmpty()) {

            List<HseFloor> filteredUnitItems = subLocationArrayList_temp.stream()
                    .filter(item -> Objects.equals(item.getSiteId(), StorageManager.getInstance().getSite_id()))
                    .collect(Collectors.toList());

            subLocationArrayList.clear();
            subLocationArrayList.addAll(filteredUnitItems);
            floorsAdapter = new FloorsAdapter(this, subLocationArrayList);
            subLocationTextView.setAdapter(floorsAdapter);
        }

    }

    /*@AfterPermissionGranted(CAMERA_REQUEST_ITEM)
    public void openItemCamera() {
        if (hasCameraPermission()) {
            try {
                Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                File photoFile = null;
                try {
                    photoFile = createImageFile("Item");
                } catch (IOException ex) {
                    // Error occurred while creating the File
                }

                if (photoFile != null) {
                    Uri photoURI = FileProvider.getUriForFile(this,
                            "com.utopia.inventorymanagement",
                            photoFile);
                    takePictureIntent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI);
                    //startActivityForResult(takePictureIntent, CAMERA_REQUEST);
                    itemCameraLauncher.launch(takePictureIntent);
                }
            } catch (ActivityNotFoundException e) {
                Toast.makeText(this, "Camera app not found", Toast.LENGTH_SHORT).show();
            }
        } else {
            // Ask for one permission
            String[] perms = {};
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES, Manifest.permission.CAMERA};
            } else {
                perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA};
            }

            EasyPermissions.requestPermissions(this, getString(R.string.rationale_camera), CAMERA_REQUEST_ITEM, perms);
        }
    }*/



    public boolean isValidate() {
        boolean returnValue = true;
        String message = "";

        if (subLocation.isEmpty()) {
            message = "Please select floor.";
            returnValue = false;
        }

        if (location.isEmpty()) {
            message = "Please select building.";
            returnValue = false;
        }

        if (targetAudience.isEmpty()) {
            message = "Please select department.";
            returnValue = false;
        }

        if (etNoOfEmployees.getText().toString().isEmpty()) {
            message = "Please enter No of Employees.";
            returnValue = false;
        }

        if (safetyTrainingTopic.isEmpty()) {
            message = "Please select Safety Training Topic.";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(this, message, Toast.LENGTH_SHORT).show();
        }

        return returnValue;
    }
}